<?php


namespace Controller;

use Traits\TResponse;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Service\Call as CallService;

class Call
{
    use TResponse;

    private $callService;

    public function __construct(CallService $callService) {
        $this->callService = $callService;
    }

    public function findCalls(Request $request, Response $response) {
        ini_set('max_execution_time', '900');
        set_time_limit(900);
        try {
            //$clientes = $request->getParameter('CDCLIENTE');
            $clientes   = ["J26269316000177"];
            $conditions = array (
                array (
                    "columnName" => "STATUS",
                    "operator"	 => "IN",
                    "value"		 => ["O", "P", "W"]
                ),
                array (
                    "columnName" => "CALL_WITHOUT_LABELS_CHECK",
                    "operator"	 => "LIKE_I",
                    "value"		 => "%N%"
                ),
                array (
                    "columnName" => "REPORTED_BY",
                    "operator"	 => "IN",
                    "value"		 => ["000000002930"]
                )
            );
            //var_dump($request->getParameters());
            $param = $request->getParameters();
            $order = null;
            if(!empty($param['order'])){
                $order = $param['order'];
            }
            $page  = null;
            if(!empty($param['page'])){
                $page = $param['page'];
            }
            $limit = null;
            if(!empty($param['limit'])){
                $limit = $param['limit'];
            }
            $data = $this->callService->findCalls($clientes, $conditions, $order, $page, $limit);
            $this->sendResponse($data, 200);
        } catch(\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findCallComments(Request $request, Response $response) {
        try {
            $callType = $request->getParameter('CALL_TYPE');
            $callRelationship = $request->getParameter('CALL_RELATIONSHIP');
            $data = $this->callService->findCallComments($callRelationship, $callType);
            $this->sendResponse($data, 200);
        } catch(\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findCallAttachments(Request $request, Response $response) {
        try {
            $callType = $request->getParameter('CALL_TYPE');
            $callRelationship = $request->getParameter('CALL_RELATIONSHIP');
            $param = $request->getParameters();
            $commentId = null;
            if(!empty($param['COMMENT_ID'])){
                $commentId = $param['COMMENT_ID'];
            }
            $filename  = null;
            if(!empty($param['FILENAME'])){
                $filename = $param['FILENAME'];
            }
            $data = $this->callService->findCallAttachments($callRelationship, $callType, $commentId, $filename);
            $this->sendResponse($data, 200);
        } catch(\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCall(Request $request, Response $response)
    {
        try {
            $callType = $request->getParameter('CALL_TYPE');
            $callRelationship = $request->getParameter('CALL_RELATIONSHIP');
            $call = $this->callService->getCall($callRelationship, $callType);
            $this->sendResponse(array("data" => $call), 200);
        }catch (\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
