import store from '@/store';
import Vue from 'vue';
import { Component } from 'vue-property-decorator';

/**
 * Microservice
 */
@Component
export default class Mircroservice extends Vue {
  private page: string = '';

  public microservicePath() {
    const { module, page } = store.getters.routerParams;

    if (process.env.NODE_ENV === 'production') {
      return `/modules/${module}`;
    }

    const userAuth = JSON.stringify({
      LOGIN_TOKEN: localStorage.getItem('LOGIN_TOKEN'),
      LOGIN_USER: localStorage.getItem('LOGIN_USER'),
      LOGIN_USER_NAME: localStorage.getItem('LOGIN_USER_NAME'),
    });

    if (!this.page) {
      this.page = page;
    }
    return `${process.env.VUE_APP_MODULE_END_POINT}?page=${this.page}&user_auth=${userAuth}`;
  }
}
